    <!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <meta http-equiv="x-ua-compatible" content="ie=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="generator" content="ExDoc v0.15.1">
    <title>BachelorThesis.Gettext – bachelor_thesis v0.0.1</title>
    <link rel="stylesheet" href="dist/app-af302bfcc4.css" />
    
    <script src="dist/sidebar_items-1963507629.js"></script>
  </head>
  <body data-type="modules">
    <script>try { if(localStorage.getItem('night-mode')) document.body.className += ' night-mode'; } catch (e) { }</script>

    <div class="main">
<button class="sidebar-toggle">
  <i class="icon-menu"></i>
</button>
<section class="sidebar">

  
  <a href="api-reference.html" class="sidebar-projectLink">
    <div class="sidebar-projectDetails">
      <h1 class="sidebar-projectName">
        bachelor_thesis
      </h1>
      <h2 class="sidebar-projectVersion">
        v0.0.1
      </h2>
    </div>
    
  </a>

  <div class="sidebar-search">
    <i class="icon-search"></i>
    <input type="text" class="sidebar-searchInput" placeholder="search" autocomplete="off" />
  </div>

  <ul class="sidebar-listNav">
    <li><a id="extras-list" href="#full-list">Pages</a></li>

    
      <li><a id="modules-list" href="#full-list">Modules</a></li>
    

    

    
  </ul>
  <div class="gradient"></div>
  <ul id="full-list" class="sidebar-fullList"></ul>
</section>

<section class="content">
  <div class="content-outer">
    <div id="content" class="content-inner">


      <h1>
        <small class="visible-xs">bachelor_thesis v0.0.1</small>
        BachelorThesis.Gettext
        
        
      </h1>

      
        <section id="moduledoc">
          <p>A module providing Internationalization with a gettext-based API.</p>
<p>By using <a href="https://hexdocs.pm/gettext">Gettext</a>,
your module gains a set of macros for translations, for example:</p>
<pre><code class="elixir">import BachelorThesis.Gettext

# Simple translation
gettext &quot;Here is the string to translate&quot;

# Plural translation
ngettext &quot;Here is the string to translate&quot;,
         &quot;Here are the strings to translate&quot;,
         3

# Domain-based translation
dgettext &quot;errors&quot;, &quot;Here is the error message to translate&quot;</code></pre>
<p>See the <a href="https://hexdocs.pm/gettext">Gettext Docs</a> for detailed usage.</p>

        </section>
      

      
        <section id="summary" class="details-list">
          <h1 class="section-heading">
            <a class="hover-link" href="#summary">
              <i class="icon-link"></i>
            </a>
            Summary
          </h1>
          

          
  <div class="summary-functions summary">
    <h2>
      <a href="#functions">Functions</a>
    </h2>
    <div class="summary-row">
  <div class="summary-signature">
    <a href="#dgettext/3">dgettext(domain, msgid, bindings \\ Macro.escape(%{}))</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#dgettext_noop/2">dgettext_noop(domain, msgid)</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#dngettext/5">dngettext(domain, msgid, msgid_plural, n, bindings \\ Macro.escape(%{}))</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#dngettext_noop/3">dngettext_noop(domain, msgid, msgid_plural)</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#gettext/2">gettext(msgid, bindings \\ Macro.escape(%{}))</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#gettext_noop/1">gettext_noop(msgid)</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#handle_missing_bindings/2">handle_missing_bindings(exception, incomplete)</a>
  </div>
  
    <div class="summary-synopsis"><p>Default handling for missing bindings</p>
</div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#lgettext/4">lgettext(locale, domain, msgid, bindings)</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#lngettext/6">lngettext(locale, domain, msgid, msgid_plural, n, bindings)</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#ngettext/4">ngettext(msgid, msgid_plural, n, bindings \\ Macro.escape(%{}))</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#ngettext_noop/2">ngettext_noop(msgid, msgid_plural)</a>
  </div>
  
</div>

  </div>


          

        </section>
      

      

      
        <section id="functions" class="details-list">
          <h1 class="section-heading">
            <a class="hover-link" href="#functions">
              <i class="icon-link"></i>
            </a>
            Functions
          </h1>
          <div class="detail" id="dgettext/3">
  
    <span id="dgettext/2" />
  
  <div class="detail-header">
    <a href="#dgettext/3" class="detail-link" title="Link to this macro">
      <i class="icon-link"></i>
    </a>
    <span class="signature">dgettext(domain, msgid, bindings \\ Macro.escape(%{}))</span>
    
    
      <span class="note">(macro)</span>
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="dgettext_noop/2">
  
  <div class="detail-header">
    <a href="#dgettext_noop/2" class="detail-link" title="Link to this macro">
      <i class="icon-link"></i>
    </a>
    <span class="signature">dgettext_noop(domain, msgid)</span>
    
    
      <span class="note">(macro)</span>
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="dngettext/5">
  
    <span id="dngettext/4" />
  
  <div class="detail-header">
    <a href="#dngettext/5" class="detail-link" title="Link to this macro">
      <i class="icon-link"></i>
    </a>
    <span class="signature">dngettext(domain, msgid, msgid_plural, n, bindings \\ Macro.escape(%{}))</span>
    
    
      <span class="note">(macro)</span>
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="dngettext_noop/3">
  
  <div class="detail-header">
    <a href="#dngettext_noop/3" class="detail-link" title="Link to this macro">
      <i class="icon-link"></i>
    </a>
    <span class="signature">dngettext_noop(domain, msgid, msgid_plural)</span>
    
    
      <span class="note">(macro)</span>
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="gettext/2">
  
    <span id="gettext/1" />
  
  <div class="detail-header">
    <a href="#gettext/2" class="detail-link" title="Link to this macro">
      <i class="icon-link"></i>
    </a>
    <span class="signature">gettext(msgid, bindings \\ Macro.escape(%{}))</span>
    
    
      <span class="note">(macro)</span>
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="gettext_noop/1">
  
  <div class="detail-header">
    <a href="#gettext_noop/1" class="detail-link" title="Link to this macro">
      <i class="icon-link"></i>
    </a>
    <span class="signature">gettext_noop(msgid)</span>
    
    
      <span class="note">(macro)</span>
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="handle_missing_bindings/2">
  
  <div class="detail-header">
    <a href="#handle_missing_bindings/2" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">handle_missing_bindings(exception, incomplete)</span>
    
    
    
  </div>
  <section class="docstring">
    <p>Default handling for missing bindings.</p>
<p>This function is called when there are missing bindings in a translation. It
takes a <a href="https://hexdocs.pm/gettext/0.13.1/Gettext.MissingBindingsError.html"><code class="inline">Gettext.MissingBindingsError</code></a> struct and the translation with the
wrong bindings left as is with the <code class="inline">%{}</code> syntax.</p>
<p>For example, if something like this is called:</p>
<pre><code class="elixir">MyApp.Gettext.gettext(&quot;Hello %{name}, welcome to %{country}&quot;, name: &quot;Jane&quot;, country: &quot;Italy&quot;)</code></pre>
<p>and our <code class="inline">it/LC_MESSAGES/default.po</code> looks like this:</p>
<pre><code class="elixir">msgid &quot;Hello %{name}, welcome to %{country}&quot;
msgstr &quot;Ciao %{name}, benvenuto in %{cowntry}&quot; # (typo)</code></pre>
<p>then Gettext will call:</p>
<pre><code class="elixir">MyApp.Gettext.handle_missing_bindings(exception, &quot;Ciao Jane, benvenuto in %{cowntry}&quot;)</code></pre>
<p>where <code class="inline">exception</code> is a struct that looks like this:</p>
<pre><code class="elixir">%Gettext.MissingBindingsError{
  backend: MyApp.Gettext,
  domain: &quot;default&quot;,
  locale: &quot;it&quot;,
  msgid: &quot;Hello %{name}, welcome to %{country}&quot;,
  bindings: [:country],
}</code></pre>
<p>The return value of the <code class="inline">c:handle_missing_bindings/2</code> callback is used as the
translated string that the translation macros and functions return.</p>
<p>The default implementation for this function uses <a href="https://hexdocs.pm/logger/Logger.html#error/1"><code class="inline">Logger.error/1</code></a> to warn
about the missing binding and returns the translated message with the
incomplete bindings.</p>
<p>This function can be overridden. For example, to raise when there are missing
bindings:</p>
<pre><code class="elixir">def handle_missing_bindings(exception, _incomplete) do
  raise exception
end</code></pre>
<p>Callback implementation for <a href="https://hexdocs.pm/gettext/0.13.1/Gettext.Backend.html#c:handle_missing_bindings/2"><code class="inline">Gettext.Backend.handle_missing_bindings/2</code></a>.</p>

  </section>
</div>
<div class="detail" id="lgettext/4">
  
  <div class="detail-header">
    <a href="#lgettext/4" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">lgettext(locale, domain, msgid, bindings)</span>
    
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="lngettext/6">
  
  <div class="detail-header">
    <a href="#lngettext/6" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">lngettext(locale, domain, msgid, msgid_plural, n, bindings)</span>
    
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="ngettext/4">
  
    <span id="ngettext/3" />
  
  <div class="detail-header">
    <a href="#ngettext/4" class="detail-link" title="Link to this macro">
      <i class="icon-link"></i>
    </a>
    <span class="signature">ngettext(msgid, msgid_plural, n, bindings \\ Macro.escape(%{}))</span>
    
    
      <span class="note">(macro)</span>
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="ngettext_noop/2">
  
  <div class="detail-header">
    <a href="#ngettext_noop/2" class="detail-link" title="Link to this macro">
      <i class="icon-link"></i>
    </a>
    <span class="signature">ngettext_noop(msgid, msgid_plural)</span>
    
    
      <span class="note">(macro)</span>
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>

        </section>
      

      
          <footer class="footer">
        <p>
          <span class="line">
            Built using
            <a href="https://github.com/elixir-lang/ex_doc" title="ExDoc" rel="help" target="_blank">ExDoc</a> (v0.15.1),
          </span>
          <span class="line">
            designed by
            <a href="https://twitter.com/dignifiedquire" target="_blank" title="@dignifiedquire">Friedel Ziegelmayer</a>.
            </span>
        </p>
        <button class="night-mode-toggle" />
      </footer>
    </div>
  </div>
</section>
</div>
  <script src="dist/app-e9767fa739.js"></script>
  </body>
</html>

